#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\delay.h>

// sensori
//senzori sunt conectati pe portul A , la pini PA0- SENZOR1, PA1 - SENZOR2, PA2- SENZOR3, PA3 - SENZOR4,PA4 - SENZOR5
//SENZORI SUNT NUMEROTATI DE LA DREAPTA LA STANGA
#define PORT_SENZORI PORTA
#define DDR_SENZORI DDRA
#define SENZ_L2 _BV(PA4)
#define SENZ_L1 _BV(PA3)
#define SENZ_C _BV(PA2)
#define SENZ_R1 _BV(PA1)
#define SENZ_R2 _BV(PA0)

// motoare
#define PORT_MOTOARE PORTC
#define DDR_MOTOARE DDRC
#define M1_LEFT PC2
#define M1_RIGHT PC3
#define M2_FW PC0
#define M2_REV PC1
//semnal senzori
//#define IN PINA

void stanga();
void dreapta();
void inainte();
void inapoi();
void stop();
void inapoi_dreapta();
void inapoi_stanga();
void init_io();

int main() {
	unsigned char IN;
	init_io();
	
	/*if (!(IN & _BV(SENZ_L1)))
		PORT_MOTOARE &= ~(_BV(M1_LEFT));
	else
		PORT_MOTOARE |= _BV(M1_LEFT);
		
	if (!(PINA & _BV(SENZ_R1)))
		PORT_MOTOARE &= ~(_BV(M1_RIGHT));
	else	
		PORT_MOTOARE |= _BV(M1_RIGHT);*/
	IN = PINA;
	
	while (1) {
		_delay_ms(800);
		
		IN = PINA;
		
		if (!(IN & SENZ_C))
			inainte();
		if ((!(IN & SENZ_C) && !(IN & SENZ_L1)) || !(IN & SENZ_L1))
			stanga();
		if ((!(IN & SENZ_C) && !(IN & SENZ_R1)) || !(IN & SENZ_R1))
			dreapta();
		if ((IN & SENZ_C)!=0 && (IN & SENZ_L1)!=0 && (IN & SENZ_R1)!=0
			&& (IN & SENZ_L2)!=0 && (IN & SENZ_R2)!=0)
			stop();	
		if(!(IN & SENZ_L2))
			inapoi_dreapta();
		if(!(IN & SENZ_R2))
			inapoi_stanga();
	}
	
	return 0;
}

void init_io() {
	//DDRC |= _BV(PC3) | _BV(PC4) | _BV(PC5) | _BV(PC6) | _BV(PC7) | _BV(PC2) | _BV(PC1) |_BV(PC0);
	DDR_MOTOARE = 0xFF;		// output
	//PORT_MOTOARE = 0X00;
	DDR_SENZORI = 0x00;		// input
	//PORT_SENZORI = 0XFF;
}

void stanga() {
	PORT_MOTOARE = _BV(M1_LEFT);
	PORT_MOTOARE &= ~(_BV(M1_RIGHT));
	PORT_MOTOARE |= _BV(M2_FW);
}

void dreapta() {
	PORT_MOTOARE = _BV(M1_RIGHT);
	PORT_MOTOARE &= ~(_BV(M1_LEFT));
	PORT_MOTOARE |= _BV(M2_FW);
}

void inainte() {
	PORT_MOTOARE &= ~(_BV(M1_LEFT));
	PORT_MOTOARE &= ~(_BV(M1_RIGHT));
	PORT_MOTOARE &= ~(_BV(M2_REV));
	PORT_MOTOARE |= _BV(M2_FW);
}

void inapoi() {
	PORT_MOTOARE &= ~(_BV(M1_LEFT));
	PORT_MOTOARE &= ~(_BV(M1_RIGHT));
	PORT_MOTOARE &= ~(_BV(M2_FW));
	PORT_MOTOARE |= _BV(M2_REV);
}

void inapoi_dreapta(){
	PORT_MOTOARE = _BV(M1_RIGHT);
	PORT_MOTOARE &= ~(_BV(M1_LEFT));
	PORT_MOTOARE |= _BV(M2_REV);
}

void inapoi_stanga(){
	PORT_MOTOARE = _BV(M1_LEFT);
	PORT_MOTOARE &= ~(_BV(M1_RIGHT));
	PORT_MOTOARE |= _BV(M2_REV);
}

void stop() {
	PORT_MOTOARE = 0x00;
}
